#include "probe.h"


int
probe_P (ProbeData * probe, int flag, DoubleImage * P)
{
  int i;
  if (flag)
    for (i = 0; i < probe->nsamples; i++)
    {
      P->data[i] =
        patch_area (probe,
                    i) * (probe->map[i].r + probe->map[i].g +
                          probe->map[i].b) / 3.0;
    }
  else
    for (i = 0; i < probe->nsamples; i++)
    {
      P->data[i] =
        (probe->map[i].r + probe->map[i].g + probe->map[i].b) / 3.0;
    }
  return 0;
}

double
doubleimage_mean (DoubleImage * image)
{
  int i;
  double x = 0.0;
  for (i = 0; i < image->size; i++)
  {
    x += image->data[i];
  }
  return x / image->size;
}

double
doubleimage_variance (DoubleImage * image)
{
  int i;
  double x = 0.0;
  double x2 = 0.0;
  for (i = 0; i < image->size; i++)
  {
    x += image->data[i];
    x2 += image->data[i] * image->data[i];
  }
  x = x / image->size;
  x2 = x2 / image->size;
  return (x2 - x * x);
}

float
find_mask (ProbeData * probe, float lambda, IntImage * mask)
{
  // Is this the correct threshold function needs to be used.

  int i;
  float mean;
  float std;
  float threshold;
  //float c;
  int mask_count = 0;
  DoubleImage *P;

  P = (DoubleImage *) malloc (sizeof (DoubleImage));
  P->usize = probe->usize;
  P->vsize = probe->vsize;
  P->size = probe->nsamples;
  alloc_doubleimage (P);

  // this can be twiddled
  probe_P (probe, 1, P);

  mean = doubleimage_mean (P);
  std = sqrt (doubleimage_variance (P));

  threshold = lambda * std;

  for (i = 0; i < probe->nsamples; i++)
  {
    if (P->data[i] > threshold)
    {
      mask->data[i] = 1;
      mask_count++;
    }
    else
    {
      mask->data[i] = 0;
    }
  }
  printf ("Nonzero pixels found : %d\n", mask_count);

  free_doubleimage (P);
  return threshold;
}
