#include "probe.h"

void alloc_intimage (IntImage * image)
{
  // should the interface to this be changed ? probably

  image->data = (int *) malloc (sizeof (int) * image->size);
}

void free_intimage (IntImage * image)
{
  free (image->data);
  free (image);
}

void free_doubleimage (DoubleImage * image)
{
  free (image->data);
  free (image);
}

void init_intimage (IntImage * image)
{
  for (int i = 0; i < image->size; i++) image->data[i] = 0;
}

IntImage *
new_image (IntImage * image)
{
  IntImage *newimage;
  int i;

  if ((newimage = (IntImage *) malloc (sizeof (IntImage))) == NULL)
    return NULL;

  if (image == NULL)
  {
    newimage->size = 0;
    newimage->usize = 0;
    newimage->vsize = 0;
    newimage->data = NULL;
  }
  else
  {
    if ((newimage = (IntImage *) malloc (sizeof (IntImage))) == NULL)
      return NULL;

    newimage->size = image->size;
    newimage->usize = image->usize;
    newimage->vsize = image->vsize;

    if ((newimage->data =
         (int *) malloc (sizeof (int) * image->size)) == NULL)
    {
      free (newimage);
      return NULL;
    }

    for (i = 0; i < image->size; i++)
      newimage->data[i] = 0;
  }

  return newimage;
}

void alloc_doubleimage (DoubleImage * image)
{
  image->data = (double *) malloc (sizeof (double) * image->size);
}

void copy_intimage (IntImage * a, IntImage * b)
{
  for (int i = 0; i < a->size; i++) b->data[i] = a->data[i];
}

bool
subset_intimage (IntImage * a, IntImage * b, int x, int y)
{
  // determine if a is a subset of b or not.
  int i;
  bool value = 0;

  for (i = 0; i < a->size; i++)
    if (a->data[i] == x)
    {
      value = 1;
      if (b->data[i] != y) return 0;
    }
  return value;
}
