#include "probe.h"

inline int
index (int i, int j, int u)
{
  return u * j + i;
}

void erode (IntImage * image, IntImage * output)
{
  int i, j;
  int p, q;
  int sum;
  for (j = 1; j < image->vsize - 1; j++)
    for (i = 1; i < image->usize - 1; i++)
    {
      sum = 0;
      for (p = -1; p < 2; p++)
        for (q = -1; q < 2; q++)
        {
          sum += (image->data[index (i + p, j + q, image->usize)] > 0);
        }

      if (sum < 9)
        output->data[index (i, j, image->usize)] = 0;
      else
        output->data[index (i, j, image->usize)] = 1;

    }
}

void dilate (IntImage * image, IntImage * output)
{
  int i, j;
  int p, q;
  int sum;
  for (j = 1; j < image->vsize - 1; j++)
    for (i = 1; i < image->usize - 1; i++)
    {
      sum = 0;
      for (p = -1; p < 2; p++)
        for (q = -1; q < 2; q++)
          sum += (image->data[index (i + p, j + q, image->usize)] > 0);

      if (sum > 0)
        output->data[index (i, j, image->usize)] = 1;
      else
        output->data[index (i, j, image->usize)] = 0;
    }
}


void clean_mask (IntImage * image, IntImage * output)
{
  IntImage *temp1;

  temp1 = new_image (image);

  dilate (image, temp1);
  dilate (temp1, output);
  erode (output, temp1);
  erode (temp1, output);

  free_intimage (temp1);
}
