#include "probe.h"

void lights_ascii_writer (DList * light_array,
                     int nregions, int lightcount, char *filename)
{
  DListElmt *node;
  DList *lightlist;
  Light *light;
  FILE *fid;
  int i;



  fid = fopen (filename, "wb");
  for (i = 1; i <= nregions; i++)
  {
    lightlist = light_array + i;
    dlist_iter (lightlist, node)
    {
      light = (Light *) dlist_data (node);
      fprintf (fid, "% 1.6f % 1.6f % 1.6f % 1.6f % 3.6f % 3.6f % 3.6f\n",
               light->pos[0],
               light->pos[1],
               light->pos[2],
               light->area,
               light->color[0], light->color[1], light->color[2]);
    }
  }
}


void lights_binary_writer (DList * light_array,
                      int nregions, int size, char *filename)
{
  // do the double  translation
  DListElmt *node;
  Light *light;
  FILE *fid;
  int i;
  DList *lightlist;

  fid = fopen (filename, "w");
  fwrite (&size, sizeof (int), 1, fid);

  for (i = 1; i <= nregions; i++)
  {
    lightlist = light_array + i;
    dlist_iter (lightlist, node)
    {
      light = (Light *) dlist_data (node);

      fwrite (light->pos, sizeof (double), 1, fid);
      fwrite (light->pos + 1, sizeof (double), 1, fid);
      fwrite (light->pos + 2, sizeof (double), 1, fid);
      fwrite (&(light->area), sizeof (double), 1, fid);
      fwrite (light->color, sizeof (double), 1, fid);
      fwrite (light->color + 1, sizeof (double), 1, fid);
      fwrite (light->color + 2, sizeof (double), 1, fid);
    }

  }
}
